import { PublicKey } from "@solana/web3.js";
import { ITokenBonding, IPricingCurve } from ".";
export declare class BondingHierarchy {
    parent?: BondingHierarchy;
    child?: BondingHierarchy;
    tokenBonding: ITokenBonding;
    pricingCurve: IPricingCurve;
    wrappedSolMint: PublicKey;
    constructor({ parent, child, tokenBonding, pricingCurve, wrappedSolMint }: {
        parent?: BondingHierarchy;
        child?: BondingHierarchy;
        tokenBonding: ITokenBonding;
        pricingCurve: IPricingCurve;
        wrappedSolMint: PublicKey;
    });
    toArray(): BondingHierarchy[];
    lowest(one: PublicKey, two: PublicKey): PublicKey;
    /**
     * Get the path from one token to another.
     *
     * @param one
     * @param two
     */
    path(one: PublicKey, two: PublicKey): BondingHierarchy[];
    /**
     * Find the bonding curve whose target is this mint
     *
     * @param mint
     */
    findTarget(mint: PublicKey): ITokenBonding;
    /**
     * Does this hierarchy contain all of these mints?
     *
     * @param mints
     */
    contains(...mints: PublicKey[]): boolean;
}
//# sourceMappingURL=bondingHierarchy.d.ts.map